    option casemap:none
    option frame:auto 
 
    .nolist
    .nocref
WIN32_LEAN_AND_MEAN equ 1
    include windows.inc
	include CommCtrl.INC
	include winbase.inc
	include shellapi.inc
	include Winuser.inc
	include commdlg.INC
    .list
    .cref
    includelib advapi32.lib
    includelib user32.lib
    includelib kernel32.lib
    includelib gdi32.lib
	includelib comctl32.lib
	includelib Shell32.lib
	includelib comdlg32.lib
    
ID_MAINMENU          equ	    102
DLG_ABOUT            equ        103
ID_FILE_EXIT         equ	    40001
ID_FILE_NEW          equ	    40002
ID_FILE_OPEN         equ	    40003
ID_FILE_SAVEAS       equ        40005
ID_WINDOW_CASCADE    equ        40008
ID_WINDOW_TILE       equ        40009
ID_FILE_CLOSE        equ        40010
ID_FILE_CLOSEALL     equ        40011
ID_EDIT_CUT          equ        40015
ID_EDIT_COPY         equ        40016
ID_EDIT_PASTE        equ        40017
					
IDM_HELP_ABOUT       equ        5000
IDM_WND_TILE         equ	    5001
IDM_FIRSTCHILD       equ	    5500
IDC_MDI_CLIENT		 equ		500
IDC_CHILD_EDIT		 equ		101
ID_MDI_FIRSTCHILD	 equ		50000 
IDM_HELPABOUT	     equ        5002 


.data
ClassName 	    db "MDIWindowClass", 0
ChildClassName  db "MDIChildWindowClass",0
FileDefExt      db 'All Files (*.*)',0,'*.*',0			     
    			db 'Rich Text Files(*.rtf)',0,'*.rtf',0
    			db 'Assembly Files (*.asm)',0,'*.asm',0
    		    db 'Include Files (*.inc)',0,'*.inc',0
    		    db 'Resorce Files (*.rc)',0,'*.rc',0
    		    db 'Text Files (*.txt)',0,'*.txt',0,0
DefExt		db  "txt",0
untitled	db 'Untitled',0
statwidths	dd 100, -1 

.data?
hWndClient  	 HWND ?
hInstance 	     HINSTANCE ?
CommandLine 	 LPSTR ? 
hMainWindow 	 HWND ?
ofn              OPENFILENAME <>

CTEXT MACRO text:VARARG
local TxtName
.data
TxtName BYTE text,0
.code
EXITM <ADDR TxtName>
ENDM


    .code
;---------------------------------------------------------------------------------

WinMainCRTStartup proc FRAME

    invoke GetModuleHandleA, NULL
    mov    hInstance, rax
    invoke GetCommandLineA
    mov    CommandLine, rax
    invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
    invoke ExitProcess, eax

WinMainCRTStartup endp

;------------------------------------------------------------------------
AboutDlgProc proc FRAME hDlg:HWND, msg:UINT, wParam:WPARAM, lParam:LPARAM
    
    
			.if edx==WM_CLOSE
				invoke EndDialog,rcx, TRUE
                    mov rax,-1
                    ret
			.elseif edx==WM_COMMAND            
                .if r8==IDOK
                    invoke EndDialog,rcx, TRUE
                    mov rax,-1
                    ret
                .endif
        .endif 
    xor rax,rax
    ret

 AboutDlgProc endp
;-----------------------------------------------------------------------
LoadTextFileToEdit proc frame hEdit:HWND ,pszFileName :LPCTSTR 

local	hFile		:HANDLE 
local	pszFileText	:LPSTR 
local	dwFileSize	:DWORD
local	bSuccess    :QWORD
local	dwRead		:DWORD 


    mov hEdit,rcx
    mov pszFileName,rdx
	invoke CreateFile,pszFileName, GENERIC_READ or GENERIC_WRITE, FILE_SHARE_READ, NULL,
						OPEN_EXISTING, 0, NULL
	mov hFile,rax
	.if (rax != INVALID_HANDLE_VALUE)
		invoke GetFileSize,hFile, NULL
		mov dwFileSize,eax
		.if (eax != -1)			
			mov  edx,eax
			add edx,1
			invoke GlobalAlloc, GPTR, edx
			 mov pszFileText,rax
			.if (pszFileText != NULL)
				invoke ReadFile,hFile, pszFileText, dwFileSize, addr dwRead, NULL
				.if rax
					mov eax,dwFileSize
					mov rcx,pszFileText
					mov BYTE PTR[rcx+rax],0 ; Add null terminator
					invoke SetWindowText,hEdit, pszFileText
					.if rax
						mov bSuccess,rax  ; It worked!
					.endif
			     .endif
				invoke GlobalFree,pszFileText
		     .endif
	       .endif
		 invoke CloseHandle,hFile
	  .endif
	mov rax,bSuccess
	ret
LoadTextFileToEdit endp
;-----------------------------------------------------------------------
SaveTextFileFromEdit proc frame hEdit:HWND ,pszFileName :LPCTSTR 
local	hFile		    :HANDLE 
local	pszText	        :LPSTR 
local	dwFileSize	    :DWORD
local	bSuccess        :QWORD
local	dwBufferSize    :DWORD 
local   dwTextLength    :DWORD
local   dwWritten       :DWORD
	
	mov hEdit,rcx
    mov pszFileName,rdx
	invoke CreateFile,pszFileName, GENERIC_WRITE, 0, NULL,
		CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
		mov hFile,rax
	.if(rax != INVALID_HANDLE_VALUE)
		invoke GetWindowTextLength,hEdit
		mov dwTextLength,eax
		; No need to bother if there's no text.
		.if(eax > 0)
			mov eax,dwTextLength
			add eax,1
			mov dwBufferSize,eax
			invoke GlobalAlloc,GPTR, dwBufferSize
			mov pszText,rax
			.if rax
			    invoke GetWindowText,hEdit, pszText, dwBufferSize
				.if rax
                    invoke WriteFile,hFile, pszText, dwTextLength, ADDR dwWritten, NULL
					.if rax
						mov bSuccess,TRUE
					.endif
				.endif
				invoke GlobalFree,pszText
			.endif
		.endif
		invoke CloseHandle,hFile
	.endif
	mov rax,bSuccess	
	ret 
SaveTextFileFromEdit endp
;-----------------------------------------------------------------------
DoFileSave proc FRAME hwnd:HWND
local	szFileName [MAX_PATH]:BYTE


    mov hwnd,rcx

	invoke ZeroMemory, ADDR ofn, sizeof(ofn)

	mov ofn.lStructSize,sizeof(ofn)
	mov rax,hwnd
	mov  ofn.hwndOwner,rax
	lea rax,FileDefExt
	mov ofn.lpstrFilter,rax
	lea rax,szFileName
	mov ofn.lpstrFile,rax
	mov ofn.nMaxFile,MAX_PATH
	lea rax,DefExt
	mov ofn.lpstrDefExt,rax
	mov ofn.Flags,OFN_EXPLORER OR OFN_PATHMUSTEXIST OR OFN_HIDEREADONLY OR OFN_OVERWRITEPROMPT
    lea rcx,ofn
    invoke  GetSaveFileNameA, rcx
	.if rax
	
		invoke GetDlgItem, hwnd, IDC_CHILD_EDIT
		  ;mov hEdit,rax
		invoke SaveTextFileFromEdit,rax,ADDR szFileName
		.if rax 
			invoke SetWindowText, hwnd, ADDR szFileName
		.endif
	.endif
	ret
DoFileSave endp
;-----------------------------------------------------------------------
DoFileOpen proc FRAME hwnd:HWND
local	szFileName [MAX_PATH]:BYTE


    mov hwnd,rcx

	invoke ZeroMemory, ADDR ofn, sizeof(ofn)

	mov ofn.lStructSize,sizeof(ofn)
	mov rax,hwnd
	mov  ofn.hwndOwner,rax
	lea rax,FileDefExt
	mov ofn.lpstrFilter,rax
	lea rax,szFileName
	mov ofn.lpstrFile,rax
	mov ofn.nMaxFile,MAX_PATH
	lea rax,DefExt
	mov ofn.lpstrDefExt,rax
	mov ofn.Flags,OFN_EXPLORER OR OFN_PATHMUSTEXIST OR OFN_HIDEREADONLY OR OFN_OVERWRITEPROMPT
    
    lea rcx,ofn
    invoke GetOpenFileNameA,rcx
	.if rax
		invoke GetDlgItem, hwnd, IDC_CHILD_EDIT
		invoke LoadTextFileToEdit,rax,ADDR szFileName
		.if rax
			invoke SetWindowText, hwnd, ADDR szFileName
		.endif
	.endif
	ret
DoFileOpen endp
;-----------------------------------------------------------------------
CreateNewMDIChild proc FRAME hMDIClient:HWND 
local mcs	:MDICREATESTRUCT 
	
    mov hMDIClient,rcx
    lea rax,untitled
	mov mcs.szTitle, rax
	lea rax,ChildClassName
	mov mcs.szClass,rax
	mov rax,hInstance
	mov mcs.hOwner,rax
	mov mcs.x,CW_USEDEFAULT
	mov mcs.cx_,CW_USEDEFAULT
	mov mcs.y,CW_USEDEFAULT
	mov mcs.cy,CW_USEDEFAULT
	mov mcs.style,MDIS_ALLCHILDSTYLES

	invoke SendMessage,hMDIClient, WM_MDICREATE, 0, ADDR mcs
        .if(!rax)
            invoke MessageBox, hMDIClient, CTEXT("Failed To Create The Child Window"), CTEXT("Error"), MB_OK
    	.endif
	ret
CreateNewMDIChild endp
;-----------------------------------------------------------------------
ChildProc proc FRAME hwnd:HWND, msg:UINT, wParam:WPARAM, lParam:LPARAM
local		hfDefault		:HFONT 
local		hEdit			:HWND 
local		whandle			:HANDLE
local       hMenu,hFileMenu	:HMENU
local		EnableFlag		:UINT
local		rcClient		:RECT

		mov		 hwnd, rcx   
		mov		 msg, edx  
		mov		 wParam, r8   
		mov		 lParam, r9
		
		.if msg==WM_CREATE
			; Create Edit Control
			invoke CreateWindowEx,WS_EX_CLIENTEDGE, CTEXT("EDIT"),NULL, 
				WS_CHILD OR WS_VISIBLE OR WS_VSCROLL OR WS_HSCROLL OR ES_MULTILINE OR ES_AUTOVSCROLL OR ES_AUTOHSCROLL, 
				0, 0, 600, 400, hwnd, IDC_CHILD_EDIT, hInstance,NULL
			mov hEdit,rax
			.if !rax
				invoke MessageBox,hwnd,CTEXT ("Could not create edit box."), CTEXT("Error"), MB_OK OR MB_ICONERROR
			.endif
				 ;  change the font to default gui font
			invoke	GetStockObject,DEFAULT_GUI_FONT
			mov		hfDefault,rax
			invoke SendMessage, hEdit, WM_SETFONT, hfDefault, NULL	
		.elseif msg==WM_MDIACTIVATE
			invoke GetMenu,hMainWindow
			mov	hMenu,rax
			mov	rax,lParam
			.if hwnd==rax
			;being activated, enable the menus
				mov EnableFlag, MF_ENABLED
			.else
			;being de-activated, gray the menus
				mov	EnableFlag, MF_GRAYED
			.endif
			mov	eax,EnableFlag
			or		eax,MF_BYPOSITION
			invoke EnableMenuItem,hMenu, 1, eax	
			mov	eax,EnableFlag
			or		eax,MF_BYPOSITION
			invoke EnableMenuItem,hMenu, 2, eax
			
			invoke GetSubMenu,hMenu, 0
			mov hFileMenu,rax
			mov		eax,EnableFlag
			or		eax,MF_BYCOMMAND
			invoke EnableMenuItem,hFileMenu, ID_FILE_SAVEAS, eax
			mov		eax,EnableFlag
			or		eax,MF_BYCOMMAND
			invoke EnableMenuItem,hFileMenu, ID_FILE_CLOSE, eax
			invoke DrawMenuBar,hMainWindow
		.elseif msg==WM_COMMAND
				mov		rax,wParam
				and		rax,0ffffh	
				movzx   eax,ax
				.if eax==ID_FILE_OPEN
					invoke DoFileOpen,hwnd
				.elseif eax==ID_FILE_SAVEAS
					invoke DoFileSave,hwnd
				.elseif eax==ID_EDIT_CUT
					invoke SendDlgItemMessage,hwnd, IDC_CHILD_EDIT, WM_CUT, 0, 0
				.elseif eax==ID_EDIT_COPY
					invoke SendDlgItemMessage,hwnd, IDC_CHILD_EDIT, WM_COPY, 0, 0
				.elseif eax==ID_EDIT_PASTE
					invoke SendDlgItemMessage,hwnd, IDC_CHILD_EDIT, WM_PASTE, 0, 0
				.endif
		.elseif msg==WM_SIZE			
			; Calculate remaining height and size edit
			invoke GetClientRect,hwnd, addr rcClient
			invoke GetDlgItem,hwnd, IDC_CHILD_EDIT
				mov		hEdit,rax
			invoke SetWindowPos,hEdit, NULL, 0, 0, rcClient.right, rcClient.bottom, SWP_NOZORDER
			invoke DefMDIChildProc,hwnd, msg, wParam, lParam
        .else
	  invoke 		 DefMDIChildProc,hwnd, msg, wParam, lParam
	  .endif
    		ret 
ChildProc endp
;------------------------------------------------------------------------
WndProc proc FRAME hwnd:HWND, msg:UINT, wParam:WPARAM, lParam:LPARAM
local ccs           :CLIENTCREATESTRUCT 
local mcs           :CREATESTRUCT 
local hChild        :HWND 
local lpfn          :HANDLE
local hTool         :HWND 
local rcTool        :RECT
local rcClient      :RECT 
local iMDIHeight    :DWORD 
local iToolHeight   :DWORD
local hStatus       :HWND
local rcStatus      :RECT
local iStatusHeight :DWORD 
                   

		mov		 hwnd, rcx   
		mov		 msg, edx  
		mov		 wParam, r8   
		mov		 lParam, r9

        .if msg==WM_CREATE
            invoke  GetMenu,hwnd
		    invoke  GetSubMenu, rax, 2
            	mov	ccs.hWindowMenu,rax
            	mov	ccs.idFirstChild, ID_MDI_FIRSTCHILD
			invoke CreateWindowExA,WS_EX_CLIENTEDGE, CTEXT("mdiclient"), NULL,
				WS_CHILD OR WS_CLIPCHILDREN OR WS_VSCROLL OR WS_HSCROLL OR WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				hwnd, IDC_MDI_CLIENT, hInstance, addr ccs
			mov	hWndClient,rax
            .if(!rax)
                invoke MessageBox, hwnd, CTEXT("Failed To Create The Client Window"), CTEXT("Error"), MB_OK
            .endif
            invoke ShowWindow,hWndClient, SW_SHOW
        .elseif msg==WM_COMMAND 
				mov		rax,wParam
				and		rax,0ffffh	
				movzx   eax,ax
			 .if eax==ID_FILE_EXIT 
                    invoke PostMessage, hwnd, WM_CLOSE, 0, 0
             .elseif eax==ID_FILE_NEW
                invoke CreateNewMDIChild, hWndClient
				mov	hChild,rax
                .elseif eax==IDM_HELPABOUT
            	    ; Bring up the ubiquitous Ego box 
            	    lea r9,AboutDlgProc
                    invoke DialogBoxParam, hInstance ,DLG_ABOUT,hwnd,r9,NULL
                .elseif eax==ID_FILE_EXIT
					invoke PostMessage, hwnd, WM_CLOSE, 0, 0
                .elseif eax==ID_FILE_OPEN
                    invoke CreateNewMDIChild, hWndClient
				    mov	hChild,rax
                    .if rax
                        invoke DoFileOpen,rax
                    .endif
                .elseif eax==ID_WINDOW_TILE
					invoke SendMessage, hWndClient, WM_MDITILE, 0, 0
				.elseif eax==ID_WINDOW_CASCADE
					invoke SendMessage, hWndClient, WM_MDICASCADE, 0, 0
				.elseif eax==ID_FILE_CLOSE
					invoke SendMessage, hWndClient, WM_MDIGETACTIVE,0,0
					invoke SendMessage,rax, WM_CLOSE, 0, 0
				.else
                
                    .if eax==ID_MDI_FIRSTCHILD
                        invoke DefFrameProc, hwnd, hWndClient, msg, wParam, lParam
                    .else
                    
                       
                        invoke SendMessage,hWndClient, WM_MDIGETACTIVE,0,0
					       mov	hChild,rax
                        .if rax
                            invoke SendMessage,hChild, WM_COMMAND, wParam, lParam
				        .endif
                	.endif
            	  .endif
        .elseif msg==WM_CLOSE
            invoke DestroyWindow, hwnd
        .elseif msg==WM_DESTROY
            invoke PostQuitMessage, 0
        .else
			invoke DefFrameProc, hwnd, hWndClient, msg, wParam, lParam
           ret
	   .endif
	   invoke DefFrameProc, hwnd, hWndClient, msg, wParam, lParam
    xor rax,rax
	ret 
WndProc endp
;------------------------------------------------------------------------
WinMain proc FRAME hInst:HINSTANCE ,hPrevInstance:HINSTANCE ,lpCmdLine:LPSTR ,nCmdShow:UINT
local	wc		:WNDCLASSEXA 
local	msg		:MSG
local	hwnd 	:HWND     

	mov hInst, rcx   
	mov hPrevInstance, rdx  
	mov lpCmdLine, r8  
	mov nCmdShow, r9d

	invoke InitCommonControls

	mov	wc.cbSize,sizeof WNDCLASSEXA
	mov wc.style,CS_HREDRAW OR CS_VREDRAW
	lea	rax,WndProc
	mov	wc.lpfnWndProc,rax
	mov	wc.cbClsExtra,0
	mov	wc.cbWndExtra,0
	mov	rax,hInst
	mov wc.hInstance,rax
	invoke LoadIcon,NULL, IDI_APPLICATION
	mov	wc.hIcon,rax
	mov	wc.hIconSm,rax
	invoke LoadCursor,NULL, IDC_ARROW
	mov	wc.hCursor,rax		 
	mov	wc.hbrBackground,COLOR_WINDOW+1
	mov	wc.lpszMenuName,ID_MAINMENU
	lea	rax,ClassName
	mov wc.lpszClassName,rax
			 
	invoke RegisterClassExA,addr wc
	.if !rax
		invoke MessageBox,NULL,CTEXT("Window Registration Failed!"), CTEXT("Error"),
			MB_ICONEXCLAMATION OR MB_OK;
		ret
	.endif
    lea	rax,ChildProc
    mov	wc.lpfnWndProc,rax
 invoke LoadCursor, NULL, IDC_ARROW
    mov	wc.hCursor,rax
    mov	wc.hbrBackground, COLOR_3DSHADOW + 1
    mov	wc.lpszMenuName, NULL;
    lea	rax,ChildClassName
    mov	wc.lpszClassName,rax

	invoke RegisterClassExA,addr wc
	.if !rax
		invoke MessageBox,NULL,CTEXT("Failed To Register The Child Window Class"), CTEXT("Error"),
			MB_ICONEXCLAMATION OR MB_OK;
		ret
	.endif

    invoke CreateWindowExA, WS_EX_CLIENTEDGE, addr ClassName,
			    CTEXT("MDIx64"), WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
			    CW_USEDEFAULT,600, 400, NULL, NULL, hInst, NULL
	mov hMainWindow,rax

	.if !rax
		invoke MessageBox,NULL, CTEXT("Failed To Create The Main Window!"),CTEXT("Error"),
			MB_ICONEXCLAMATION OR MB_OK;
			invoke    ExitProcess, NULL
	.endif
    invoke ShowWindow,hMainWindow, SW_SHOW
    invoke UpdateWindow,hMainWindow
    .while (1)
        invoke GetMessageA, ADDR msg, NULL, 0, 0
        .break .if (!rax)
			invoke TranslateMDISysAccel,hWndClient, ADDR msg
			.if	(!eax)
				invoke TranslateMessage, ADDR msg
				invoke DispatchMessageA, ADDR msg
			.endif
    .endw
    mov   rax, msg.wParam
    ret

WinMain endp
;------------------------------------------------------------------------
end WinMainCRTStartup    
